/* GCC */
#include <iostream>
#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

#define MAXN 210
#define MAXM 420

int n, m, d;
int A[MAXN];
int TA[MAXN];
int B[MAXN];
int TB[MAXN];
vector< pair<int, int> > RES;
int k, D;

int F(int fd)
{
    int mx=0;
    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            if (((A[i]+fd+d) >= B[j]) && ((A[i]+fd-d) <= B[j]) && (TA[i] == 0) && (TB[j] == 0)){
                TA[i] = j+1;
                TB[j] = i+1;
                int f = F(fd)+1;
                if (f > mx) mx = f;
            }
        }
    }
    return mx;
}

int Fm(int fd)
{
    int mx=0;
    for (int i=0; i<n; i++){
        for (int j=0; j<m; j++){
            if (((A[i]+fd+d) >= B[j]) && ((A[i]+fd-d) <= B[j]) && (TA[i] == 0) && (TB[j] == 0)){
                TA[i] = j-1;
                TB[j] = i-1;
                int f = F(fd)+1;
                if (f > mx) mx = f;
            }
        }
    }
    return mx;
}

int main(void)
{
    freopen("chess.in", "r", stdin);
    freopen("chess.out", "w", stdout);

    scanf("%d %d %d", &n, &m, &d);
    int i, j;
    for (i=0; i<n; i++) scanf("%d", &A[i]);
    for (i=0; i<m; i++) scanf("%d", &B[i]);
/*
    sort(A, A+n);
    sort(B, B+m);
*/
    int mxA=0;
    for (i=0; i<n; i++) if (mxA < A[i]) mxA = A[i];
    int mxB=0;
    for (i=0; i<m; i++) if (mxB < B[i]) mxB = B[i];

    D = 0; k = 0;
    for (i=0; (mxA+i)<=(mxB+d); i++){
        memset(TA, 0, sizeof(TA));
        memset(TB, 0, sizeof(TB));
        int f = F(i);
        if (f > k){
            k = f;
            D = i;
            RES.clear();
            for (j=0; j<MAXN; j++){
                if (TA[j] != 0){
                    pair<int, int> t = make_pair(j+1, TA[j]);
                    RES.push_back(t);
                }
            }
        }
        /*
        f = Fm(-i);
        if (f > k){
            k = f;
            D = -i;
            RES.clear();
            for (j=0; j<MAXN; j++){
                if (TA[j] != 0){
                    pair<int, int> t = make_pair(j+1, TA[j]);
                    RES.push_back(t);
                }
            }
        }
        */
    }
/*
    for (i=-(mxB+d-mxA); i<0; i++){
        memset(TA, 0, sizeof(TA));
        memset(TB, 0, sizeof(TB));
        int f = F(i);
        if (f > k){
            k = f;
            D = i;
            RES.clear();
            for (j=0; j<MAXN; j++){
                if (TA[j] != 0){
                    pair<int, int> t = make_pair(j+1, TA[j]);
                    RES.push_back(t);
                }
            }
        }
    }
*/
    printf("%d %d\n", k, D);
    for (i=0; i<k; i++){
        printf("%d %d\n", RES[i].first, RES[i].second);
    }
    return 0;
}
