/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

struct point
{
    int ind, t, i, j;
    
    point()
    {
        ind = 0;
        t = 0;
        i = 0;
        j = 0;
    }
    
    point(int a, int b, int c, int d)
    {
        ind = a;
        t = b;
        i = c;
        j = d;
    }
};

inline bool operator< (point a, point b)
{
    return (a.ind < b.ind || (a.ind == b.ind && a.t > b.t));
}

int n, m, d, i, j, a, b, A, B, D, ans, cur, ma, lmin, lmax, Lmin, Lmax;
vector <point> points;
int inf = 1000000000;
pair <int, int> l[210], L[210];

int main()
{
    freopen("chess.in", "r", stdin);
    freopen("chess.out", "w", stdout);
    
    lmax = Lmax = 0;
    lmin = Lmin = inf;
    
    scanf("%d %d %d", &n, &m, &d);
    for(i = 0; i < n; i++)
    {
        scanf("%d", &l[i].X);
        lmin = min(lmin, l[i].X);
        lmax = max(lmax, l[i].X);
        l[i].Y = i + 1;
    }
    for(i = 0; i < m; i++)
    {
        scanf("%d", &L[i].X);
        Lmin = min(Lmin, L[i].X);
        Lmax = max(Lmax, L[i].X);
        L[i].Y = i + 1;
    }
    
    sort(l, l + n);
    sort(L, L + m);
    
    A = Lmin + d - lmax;
    B = Lmax - d - lmin;
    
    if(A >= B)
    {
        points.push_back(point(A, 1, -1, -1));
        points.push_back(point(A, -1, -1, -1));
    }
    else
        for(i = 0; i < n; i++)
            for(j = 0; j < m; j++)
            {
                a = L[j].X - l[i].X - d;
                a = max(a, A);
                
                b = L[j].X - l[i].X + d;
                b = min(b, B);
                
                if(a <= b)
                {
                    points.push_back(point(a, 1, i, j));
                    points.push_back(point(b, -1, i, j));
                }
            }
            
    sort(points.begin(), points.end());
    
    ma = 0;
    for(i = 0; i + 1 < points.size(); i++)
        if(points[i].t == 1 && points[i + 1].t == -1)
        {
            D = points[i].ind;
            a = 0;
            b = 0;
            cur = 0;
            while(b < m)
            {
                while(a < n && l[a].X + D < L[b].X - d)
                    a++;
                
                if(a == n)
                    break;
                
                if(l[a].X + D <= L[b].X + d)
                {
                    cur++;
                    a++;
                }
                    
                b++;
            }
            
            if(cur > ma)
            {
                ma = cur;
                ans = D;
            }
        }
        
    printf("%d %d\n", ma, ans);
    D = ans;
    a = 0;
    b = 0;
    while(b < m)
    {
        while(a < n && l[a].X + D < L[b].X - d)
            a++;
        
        if(a == n)
            break;
        
        if(l[a].X + D <= L[b].X + d)
        {
            printf("%d %d\n", l[a].Y, L[b].Y);
            a++;
        }
            
        b++;
    }
    
    return 0;
}










