/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int ran = 500;
int inf = 1000000000;
int n, m, i, j, k, s[200][2], a[30], mina[30], min_mina[30], l, minl, curl, min_minl;

int main()
{
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
    
    scanf("%d %d", &n, &m);
    for(i = 0; i < m; i++)
        scanf("%d %d", &s[i][0], &s[i][1]);
    
    min_minl = inf;
    srand(time(0));
    while(ran > 0)
    {
        for(i = 0; i < n; i++)
            a[i + 1] = i;
            
        random_shuffle(a + 1, a + n + 1);
        
        l = 0;
        for(i = 0; i < m; i++)
            l += abs(a[s[i][0]] - a[s[i][1]]);
        
        while(true)
        {
            minl = inf;
            
            for(i = 1; i < n; i++)
                for(j = i + 1; j <= n; j++)
                {
                    swap(a[i], a[j]);
                    
                    curl = 0;
                    for(k = 0; k < m; k++)
                        curl += abs(a[s[k][0]] - a[s[k][1]]);
                    
                    if(curl < minl)
                    {
                        minl = curl;
                        for(k = 1; k <= n; k++)
                            mina[k] = a[k];
                    }
                    
                    swap(a[i], a[j]);
                }
                
            if(minl < l)
            {
                l = minl;
                for(i = 1; i <= n; i++)
                    a[i] = mina[i];
            }
            else
                break;
        }
        
        if(l < min_minl)
        {
            min_minl = l;
            for(i = 1; i <= n; i++)
                min_mina[i] = a[i];
        }
        
        ran--;
    }
    
    printf("%d\n", min_minl);
    for(i = 1; i <= n; i++)
        a[min_mina[i]] = i;
    for(i = 0; i < n - 1; i++)
        printf("%d ", a[i]);
    printf("%d\n", a[i]);
    
    return 0;
}










