/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
using namespace std;

struct s_event
{
    int pos , Pl1 , Pl2 , status;
    s_event(int c,int d,int a,int b)
    {Pl1 = a; Pl2 = b; pos = c; status = d;}
};
bool operator < (s_event a,s_event b)
{
    if(a.pos > b.pos)
        return false;
    if(b.pos > a.pos)
        return true;
    return a.status < b.status;
}
int main()
{
    ifstream fin("chess.in");
    int n , m , d;
    fin >> n >> m >> d;
    int Vil[n] , Ct[m];
    int c_ans = 0,tmp = 0,D;
    vector<s_event> Event;
    for(int i = 0;i < n;i++)
        fin >> Vil[i];
    for(int i = 0;i < m;i++)
        fin >> Ct[i];

    bool arrVs[n][m];
    for(int i = 0;i < n;i++)
        for(int j = 0;j < m;j++)
        {
            Event.push_back({Ct[j] - Vil[i] - d, -1 , i , j});
            Event.push_back({Ct[j] - Vil[i] + d, 1 , i , j});
            arrVs[i][j] = false;
        }
    int len = Event.size();
    vector<bool> used_ver1(n) , used_ver2(m) , used(len);
    vector<pair<int , int> > way;
    sort(Event.begin(),Event.end());
    for(int i = 0;i < len;i++)
    {
        if(((Event[i].status > 0) && (arrVs[Event[i].Pl1][Event[i].Pl2])) || (!used_ver2[Event[i].Pl2] && !used_ver1[Event[i].Pl1]))
        {
                if(Event[i].status < 0)
                {
                    used_ver2[Event[i].Pl2] = true;
                    used_ver1[Event[i].Pl1] = true;
                    arrVs[Event[i].Pl1][Event[i].Pl2] = true;
                    tmp++;
                }
                else
                {
                    used_ver2[Event[i].Pl2] = false;
                    used_ver1[Event[i].Pl1] = false;
                    arrVs[Event[i].Pl1][Event[i].Pl2] = false;
                    tmp--;
                }
                if(tmp > c_ans)
                {
                    c_ans = tmp;
                    D = Event[i].pos;
                    way.clear();
                    for(int i1 = 0;i1 < n;i1++)
                        for(int i2 = 0;i2 < m;i2++)
                            if(arrVs[i1][i2])
                                way.push_back({i1,i2});
                }
        }
    }
    ofstream fout("chess.out");
    fout << c_ans << ' ' << D << endl;
    for(int i = 0;i < c_ans;i++)
        fout << way[i].first + 1 << ' ' << way[i].second + 1 << endl;
    return 0;
}
